package com.realnet.basic.Controllers;
import java.util.List;
import org.springframework.beans.factory.annotation.Autowired;
 import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;
import com.fasterxml.jackson.core.JsonProcessingException;
import org.springframework.web.bind.annotation.CrossOrigin;
import com.fasterxml.jackson.databind.JsonMappingException;
import com.realnet.config.EmailService;
import com.realnet.users.entity1.AppUser;
import com.realnet.users.service1.AppUserServiceImpl;
import com.fasterxml.jackson.databind.ObjectMapper;
import org.springframework.data.domain.*;
import com.realnet.fnd.response.EntityResponse;
import org.springframework.http.*;
import org.springframework.beans.factory.annotation.*;
import com.realnet.basic.Entity.Invoices;
import com.realnet.basic.Services.InvoicesService ;


@RequestMapping(value = "/token/Invoices")
 @CrossOrigin("*") 
@RestController
public class tokenFree_InvoicesController {
	@Autowired
	private InvoicesService Service;

@Value("${projectPath}")
	private String projectPath;
 


	@PostMapping("/Invoices")
		  public Invoices Savedata(@RequestBody Invoices data) {
		Invoices save = Service.Savedata(data)	;

		System.out.println("data saved..." + save);

 return save;
	  }
@PutMapping("/Invoices/{id}")
	public  Invoices update(@RequestBody Invoices data,@PathVariable Integer id ) {
		Invoices update = Service.update(data,id);
		System.out.println("data update..." + update);
		return update;
	}	 
//	get all with pagination
	@GetMapping("/Invoices/getall/page")
	public Page<Invoices> getall(@RequestParam(value = "page", required = false) Integer page,
			@RequestParam(value = "size", required = false) Integer size) {
		Pageable paging = PageRequest.of(page, size);
		Page<Invoices> get = Service.getAllWithPagination(paging);

		return get;

	}	
	@GetMapping("/Invoices")
	public List<Invoices> getdetails() {
		 List<Invoices> get = Service.getdetails();		
		return get;
}
// get all without authentication 

	@GetMapping("/token/Invoices")
	public List<Invoices> getallwioutsec() {
		 List<Invoices> get = Service.getdetails();		
		return get;
}
@GetMapping("/Invoices/{id}")
	public  Invoices  getdetailsbyId(@PathVariable Integer id ) {
		Invoices  get = Service.getdetailsbyId(id);
		return get;
	}
@DeleteMapping("/Invoices/{id}")
	public  ResponseEntity<?> delete_by_id(@PathVariable Integer id ) {
	Service.delete_by_id(id);
			return new ResponseEntity<>(new EntityResponse("Deleted"), HttpStatus.OK);
	
	}



}